/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
#ifndef PIDFILE_H
#define PIDFILE_H

#include <string>
#include <sys/types.h>

/// Pid file handling
/**
   @copyright Intra2net AG
*/
class PidFile
{
public:
   PidFile(const std::string &filename, bool remove_file_on_destruction=true);
   ~PidFile();

   bool check_already_running(pid_t *running_pid=NULL);
   bool write();

private:
   /// Full path to the pid file
   std::string Filename;
   /// Remove pid file on destruction
   bool RemoveFileOnDestruction;
   /// Indicates if we wrote the file (gets set by write())
   bool WroteFile;
};

#endif
